package cn.com.qmth.examcloud.core.basic.service.impl;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.commons.base.exception.StatusException;
import cn.com.qmth.examcloud.core.basic.dao.SpecialtyRepo;
import cn.com.qmth.examcloud.core.basic.dao.entity.SpecialtyEntity;
import cn.com.qmth.examcloud.core.basic.service.SpecialtyService;
import cn.com.qmth.examcloud.core.basic.service.bean.SpecialtyInfo;

@Service
public class SpecialtyServiceImpl implements SpecialtyService {

	@Autowired
	SpecialtyRepo specialtyRepo;

	@Override
	public SpecialtyEntity saveSpecialty(SpecialtyInfo info) {
		Long id = info.getId();
		String code = info.getCode();
		Boolean enable = info.getEnable();
		Long rootOrgId = info.getRootOrgId();
		String name = info.getName();

		if (null == rootOrgId) {
			throw new StatusException("B-620001", "rootOrgId is null");
		}
		SpecialtyEntity entity = null;

		if (null != id) {
			entity = specialtyRepo.findOne(id);
			if (null == entity) {
				throw new StatusException("B-620001", "id is wrong");
			}
			if (!entity.getRootOrgId().equals(rootOrgId)) {
				throw new StatusException("B-620001", "rootOrgId or id is worng");
			}
		} else if (StringUtils.isNotBlank(code)) {
			entity = specialtyRepo.findByRootOrgIdAndCode(rootOrgId, code);
			if (null == entity) {
				if (StringUtils.isBlank(name)) {
					throw new StatusException("B-620001", "name is blank");
				}
				entity = new SpecialtyEntity();
				entity.setCode(code);
				entity.setName(name);
				entity.setRootOrgId(rootOrgId);
				entity.setEnable(true);
			}
		} else {
			throw new StatusException("B-620001", "id and code can not be all null");
		}

		if (null != enable) {
			entity.setEnable(enable);
		}
		if (StringUtils.isNotBlank(name)) {
			entity.setName(name);
		}

		SpecialtyEntity saved = specialtyRepo.save(entity);

		return saved;
	}

}
